## Tool: `get_api_operation`

Get details about a particular operation in an API version.

The following sample demonstrate how to use `curl` to invoke the `get_api_operation` MCP tool.

| Curl Request |
|---|
| ```bash curl --location 'https://apihub.googleapis.com/mcp' \ --header 'content-type: application/json' \ --header 'accept: application/json, text/event-stream' \ --data '{ "method": "tools/call", "params": { "name": "get_api_operation", "arguments": { // provide these details according to the tool's MCP specification } }, "jsonrpc": "2.0", "id": 1 }' ``` |

## Input Schema

The `GetApiOperation` method's request.

### GetApiOperationRequest

| JSON representation |
|---|
| ``` { "name": string } ``` |

| Fields ||
|---|---|
| `name` | `string` Required. The name of the operation to retrieve. Format: `projects/{project}/locations/{location}/apis/{api}/versions/{version}/operations/{operation}` |

## Output Schema

Represents an operation contained in an API version in the API Hub. An operation is added/updated/deleted in an API version when a new spec is added or an existing spec is updated/deleted in a version. Currently, an operation will be created only corresponding to OpenAPI spec as parsing is supported for OpenAPI spec. Alternatively operations can be managed via create,update and delete APIs, creation of apiOperation can be possible only for version with no parsed operations and update/delete can be possible only for operations created via create API.

### ApiOperation

| JSON representation |
|---|
| ``` { "name": string, "spec": string, "details": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api_operation#Input.Schema.OperationDetails`) }, "createTime": string, "updateTime": string, "attributes": { string: { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`) }, ... }, "sourceMetadata": [ { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.SourceMetadata`) } ] } ``` |

| Fields ||
|---|---|
| `name` | `string` Identifier. The name of the operation. Format: `projects/{project}/locations/{location}/apis/{api}/versions/{version}/operations/{operation}` |
| `spec` | `string` Output only. The name of the spec will be of the format: `projects/{project}/locations/{location}/apis/{api}/versions/{version}/specs/{spec}` Note:The name of the spec will be empty if the operation is created via `CreateApiOperation` API. |
| `details` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api_operation#Input.Schema.OperationDetails`)`` Optional. Operation details. Note: Even though this field is optional, it is required for `CreateApiOperation` API and we will fail the request if not provided. |
| `createTime` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Output only. The time at which the operation was created. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |
| `updateTime` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Output only. The time at which the operation was last updated. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |
| `attributes` | ``map (key: string, value: object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`))`` Optional. The list of user defined attributes associated with the API operation resource. The key is the attribute name. It will be of the format: `projects/{project}/locations/{location}/attributes/{attribute}`. The value is the attribute values associated with the resource. An object containing a list of `"key": value` pairs. Example: `{ "name": "wrench", "mass": "1.3kg", "count": "3" }`. |
| `sourceMetadata[]` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.SourceMetadata`)`` Output only. The list of sources and metadata from the sources of the API operation. |

### OperationDetails

| JSON representation |
|---|
| ``` { "description": string, "documentation": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.Documentation`) }, "deprecated": boolean, // Union field `operation` can be only one of the following: "httpOperation": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api_operation#Input.Schema.HttpOperation`) }, "mcpTool": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api_operation#Input.Schema.McpTool`) } // End of list of possible types for union field `operation`. } ``` |

| Fields ||
|---|---|
| `description` | `string` Optional. Description of the operation behavior. For OpenAPI spec, this will map to `operation.description` in the spec, in case description is empty, `operation.summary` will be used. |
| `documentation` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.Documentation`)`` Optional. Additional external documentation for this operation. For OpenAPI spec, this will map to `operation.documentation` in the spec. |
| `deprecated` | `boolean` Optional. For OpenAPI spec, this will be set if `operation.deprecated`is marked as `true` in the spec. |
| Union field `operation`. `operation` can be only one of the following: ||
| `httpOperation` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api_operation#Input.Schema.HttpOperation`)`` The HTTP Operation. |
| `mcpTool` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api_operation#Input.Schema.McpTool`)`` The MCP Tool Operation. |

### HttpOperation

| JSON representation |
|---|
| ``` { "path": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api_operation#Input.Schema.Path`) }, "method": enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api_operation#Input.Schema.Method`) } ``` |

| Fields ||
|---|---|
| `path` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api_operation#Input.Schema.Path`)`` Optional. The path details for the Operation. Note: Even though this field is optional, it is required for `CreateApiOperation` API and we will fail the request if not provided. |
| `method` | ``enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api_operation#Input.Schema.Method`)`` Optional. Operation method Note: Even though this field is optional, it is required for `CreateApiOperation` API and we will fail the request if not provided. |

### Path

| JSON representation |
|---|
| ``` { "path": string, "description": string } ``` |

| Fields ||
|---|---|
| `path` | `string` Optional. Complete path relative to server endpoint. Note: Even though this field is optional, it is required for `CreateApiOperation` API and we will fail the request if not provided. |
| `description` | `string` Optional. A short description for the path applicable to all operations. |

### McpTool

| JSON representation |
|---|
| ``` { "name": string, "title": string, "description": string, "annotations": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api_operation#Input.Schema.ToolAnnotations`) }, "inputSchema": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api_operation#Input.Schema.OperationSchema`) }, "outputSchema": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api_operation#Input.Schema.OperationSchema`) } } ``` |

| Fields ||
|---|---|
| `name` | `string` Required. The name of the tool, unique within its parent scope (version). |
| `title` | `string` Optional. Optional title for the tool. |
| `description` | `string` Optional. Description of what the tool does. |
| `annotations` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api_operation#Input.Schema.ToolAnnotations`)`` Optional. Optional annotations for the tool. |
| `inputSchema` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api_operation#Input.Schema.OperationSchema`)`` Optional. Input schema for the operation. This can be parsed only from MCP schema type. |
| `outputSchema` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api_operation#Input.Schema.OperationSchema`)`` Optional. Output schema for the operation. This can be parsed only from MCP schema type. |

### ToolAnnotations

| JSON representation |
|---|
| ``` { "title": string, "additionalHints": { string: string, ... }, // Union field `_read_only_hint` can be only one of the following: "readOnlyHint": boolean // End of list of possible types for union field `_read_only_hint`. // Union field `_destructive_hint` can be only one of the following: "destructiveHint": boolean // End of list of possible types for union field `_destructive_hint`. // Union field `_idempotent_hint` can be only one of the following: "idempotentHint": boolean // End of list of possible types for union field `_idempotent_hint`. // Union field `_open_world_hint` can be only one of the following: "openWorldHint": boolean // End of list of possible types for union field `_open_world_hint`. } ``` |

| Fields ||
|---|---|
| `title` | `string` Optional. A human-readable title for the tool (if different from Tool.title). |
| `additionalHints` | `map (key: string, value: string)` Optional. Additional hints which may help tools and not covered in defaults. An object containing a list of `"key": value` pairs. Example: `{ "name": "wrench", "mass": "1.3kg", "count": "3" }`. |
| Union field `_read_only_hint`. `_read_only_hint` can be only one of the following: ||
| `readOnlyHint` | `boolean` Optional. Hint indicating if the tool is read-only. |
| Union field `_destructive_hint`. `_destructive_hint` can be only one of the following: ||
| `destructiveHint` | `boolean` Optional. Hint indicating if the tool may have destructive side effects. |
| Union field `_idempotent_hint`. `_idempotent_hint` can be only one of the following: ||
| `idempotentHint` | `boolean` Optional. Hint indicating if the tool is idempotent. |
| Union field `_open_world_hint`. `_open_world_hint` can be only one of the following: ||
| `openWorldHint` | `boolean` Optional. Hint indicating if the tool interacts with the open world (e.g., internet). |

### AdditionalHintsEntry

| JSON representation |
|---|
| ``` { "key": string, "value": string } ``` |

| Fields ||
|---|---|
| `key` | `string` |
| `value` | `string` |

### OperationSchema

| JSON representation |
|---|
| ``` { // Union field `value` can be only one of the following: "jsonSchema": { object } // End of list of possible types for union field `value`. } ``` |

| Fields ||
|---|---|
| Union field `value`. The value of the schema. `value` can be only one of the following: ||
| `jsonSchema` | ``object (`https://protobuf.dev/reference/protobuf/google.protobuf#struct` format)`` The JSON schema. Only valid JSON is accepted but semantic validation of schema is not supported right now. |

### Struct

| JSON representation |
|---|
| ``` { "fields": { string: value, ... } } ``` |

| Fields ||
|---|---|
| `fields` | ``map (key: string, value: value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format))`` Unordered map of dynamically typed values. An object containing a list of `"key": value` pairs. Example: `{ "name": "wrench", "mass": "1.3kg", "count": "3" }`. |

### FieldsEntry

| JSON representation |
|---|
| ``` { "key": string, "value": value } ``` |

| Fields ||
|---|---|
| `key` | `string` |
| `value` | ``value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format)`` |

### Value

| JSON representation |
|---|
| ``` { // Union field `kind` can be only one of the following: "nullValue": null, "numberValue": number, "stringValue": string, "boolValue": boolean, "structValue": { object }, "listValue": array // End of list of possible types for union field `kind`. } ``` |

| Fields ||
|---|---|
| Union field `kind`. The kind of value. `kind` can be only one of the following: ||
| `nullValue` | `null` Represents a JSON `null`. |
| `numberValue` | `number` Represents a JSON number. Must not be `NaN`, `Infinity` or `-Infinity`, since those are not supported in JSON. This also cannot represent large Int64 values, since JSON format generally does not support them in its number type. |
| `stringValue` | `string` Represents a JSON string. |
| `boolValue` | `boolean` Represents a JSON boolean (`true` or `false` literal in JSON). |
| `structValue` | ``object (`https://protobuf.dev/reference/protobuf/google.protobuf#struct` format)`` Represents a JSON object. |
| `listValue` | ``array (`https://protobuf.dev/reference/protobuf/google.protobuf#list-value` format)`` Represents a JSON array. |

### ListValue

| JSON representation |
|---|
| ``` { "values": [ value ] } ``` |

| Fields ||
|---|---|
| `values[]` | ``value (`https://protobuf.dev/reference/protobuf/google.protobuf#value` format)`` Repeated field of dynamically typed values. |

### Documentation

| JSON representation |
|---|
| ``` { "externalUri": string } ``` |

| Fields ||
|---|---|
| `externalUri` | `string` Optional. The uri of the externally hosted documentation. |

### Timestamp

| JSON representation |
|---|
| ``` { "seconds": string, "nanos": integer } ``` |

| Fields ||
|---|---|
| `seconds` | `string (https://developers.google.com/discovery/v1/type-format format)` Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be between -62135596800 and 253402300799 inclusive (which corresponds to 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z). |
| `nanos` | `integer` Non-negative fractions of a second at nanosecond resolution. This field is the nanosecond portion of the duration, not an alternative to seconds. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be between 0 and 999,999,999 inclusive. |

### AttributesEntry

| JSON representation |
|---|
| ``` { "key": string, "value": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`) } } ``` |

| Fields ||
|---|---|
| `key` | `string` |
| `value` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AttributeValues`)`` |

### AttributeValues

| JSON representation |
|---|
| ``` { "attribute": string, // Union field `Value` can be only one of the following: "enumValues": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.EnumAttributeValues`) }, "stringValues": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.StringAttributeValues`) }, "jsonValues": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.StringAttributeValues`) }, "uriValues": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.StringAttributeValues`) } // End of list of possible types for union field `Value`. } ``` |

| Fields ||
|---|---|
| `attribute` | `string` Output only. The name of the attribute. Format: projects/{project}/locations/{location}/attributes/{attribute} |
| Union field `Value`. The attribute values associated with the resource. `Value` can be only one of the following: ||
| `enumValues` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.EnumAttributeValues`)`` The attribute values associated with a resource in case attribute data type is enum. |
| `stringValues` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.StringAttributeValues`)`` The attribute values associated with a resource in case attribute data type is string. |
| `jsonValues` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.StringAttributeValues`)`` The attribute values associated with a resource in case attribute data type is JSON. |
| `uriValues` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.StringAttributeValues`)`` The attribute values associated with a resource in case attribute data type is URL, URI or IP, like gs://bucket-name/object-name. |

### EnumAttributeValues

| JSON representation |
|---|
| ``` { "values": [ { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AllowedValue`) } ] } ``` |

| Fields ||
|---|---|
| `values[]` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.AllowedValue`)`` Required. The attribute values in case attribute data type is enum. |

### AllowedValue

| JSON representation |
|---|
| ``` { "id": string, "displayName": string, "description": string, "immutable": boolean } ``` |

| Fields ||
|---|---|
| `id` | `string` Required. The ID of the allowed value. \* If provided, the same will be used. The service will throw an error if the specified id is already used by another allowed value in the same attribute resource. \* If not provided, a system generated id derived from the display name will be used. In this case, the service will handle conflict resolution by adding a system generated suffix in case of duplicates. This value should be 4-63 characters, and valid characters are /\[a-z\]\[0-9\]-/. |
| `displayName` | `string` Required. The display name of the allowed value. |
| `description` | `string` Optional. The detailed description of the allowed value. |
| `immutable` | `boolean` Optional. When set to true, the allowed value cannot be updated or deleted by the user. It can only be true for System defined attributes. |

### StringAttributeValues

| JSON representation |
|---|
| ``` { "values": [ string ] } ``` |

| Fields ||
|---|---|
| `values[]` | `string` Required. The attribute values in case attribute data type is string or JSON. |

### SourceMetadata

| JSON representation |
|---|
| ``` { "sourceType": enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.SourceType`), "originalResourceId": string, "originalResourceCreateTime": string, "originalResourceUpdateTime": string, // Union field `source` can be only one of the following: "pluginInstanceActionSource": { object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.PluginInstanceActionSource`) } // End of list of possible types for union field `source`. } ``` |

| Fields ||
|---|---|
| `sourceType` | ``enum (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.SourceType`)`` Output only. The type of the source. |
| `originalResourceId` | `string` Output only. The unique identifier of the resource at the source. |
| `originalResourceCreateTime` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Output only. The time at which the resource was created at the source. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |
| `originalResourceUpdateTime` | ``string (`https://protobuf.dev/reference/protobuf/google.protobuf#timestamp` format)`` Output only. The time at which the resource was last updated at the source. Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: `"2014-10-02T15:01:23Z"`, `"2014-10-02T15:01:23.045123456Z"` or `"2014-10-02T15:01:23+05:30"`. |
| Union field `source`. The source of the resource. `source` can be only one of the following: ||
| `pluginInstanceActionSource` | ``object (`https://docs.cloud.google.com/apigee/docs/reference/apis/apihub/mcp/tools_list/create_api#Input.Schema.PluginInstanceActionSource`)`` Output only. The source of the resource is a plugin instance action. |

### PluginInstanceActionSource

| JSON representation |
|---|
| ``` { "pluginInstance": string, "actionId": string } ``` |

| Fields ||
|---|---|
| `pluginInstance` | `string` Output only. The resource name of the source plugin instance. Format is `projects/{project}/locations/{location}/plugins/{plugin}/instances/{instance}` |
| `actionId` | `string` Output only. The id of the plugin instance action. |

### Method

Enumeration of Method types.

| Enums ||
|---|---|
| `METHOD_UNSPECIFIED` | Method unspecified. |
| `GET` | Get Operation type. |
| `PUT` | Put Operation type. |
| `POST` | Post Operation type. |
| `DELETE` | Delete Operation type. |
| `OPTIONS` | Options Operation type. |
| `HEAD` | Head Operation type. |
| `PATCH` | Patch Operation type. |
| `TRACE` | Trace Operation type. |

### NullValue

Represents a JSON `null`.

`NullValue` is a sentinel, using an enum with only one value to represent the null value for the `Value` type union.

A field of type `NullValue` with any value other than `0` is considered invalid. Most ProtoJSON serializers will emit a `Value` with a `null_value` set as a JSON `null` regardless of the integer value, and so will round trip to a `0` value.

| Enums ||
|---|---|
| `NULL_VALUE` | Null value. |

### SourceType

The possible types of the source.

| Enums ||
|---|---|
| `SOURCE_TYPE_UNSPECIFIED` | Source type not specified. |
| `PLUGIN` | Source type plugin. |

### Tool Annotations

Destructive Hint: ❌ \| Idempotent Hint: ✅ \| Read Only Hint: ✅ \| Open World Hint: ❌